<?php

namespace HCM\FPA\Calculos\Apolo;

require_once __DIR__.'/bootstrapConsumer.php';
error_reporting(E_ERROR | E_PARSE);
ini_set("memory_limit","2048M");

use Teknisa\Model\Gestaopessoas\Repositories\FpaCalculoconsumer;
use HCM\Util\Repositories;
use HCM\Util\DateUtil;
use HCM\Util\FPA;
use HCM\Util\HCMParameters;
use HCM\FPA\Entity\FpatipocalculoEntity;
use HCM\Util\Mail\Mail;
use HCM\FPA\Calculos\Apolo\PercorreCalculoConsumer;
use Zeedhi\Framework\Session\Session;
use Teknisa\Libs\Util\SMTP;

class MigracaoConsumer extends \Zeedhi\Queue\Consumer {

    const QUEUE_NAME_MIGRACAO = "hcm_migracaoFichaFinanceira_";

	protected static $queueName = '/queue/';
    public $fpaCalculoConsumer;
    private $nrcalculoconsumer;
    private $dsemailoper;
    private $cdoperador;
    private $dtmescompetencia;
    private $nrorg;
    private $tp_processamento;
    private $tipo_calculo;
    private $nrFormulario;
    private $pid;
    private $corpoEmail;
    
    public function __construct($hcmParameters, $migracaoFichaFinanceiraService, $entityManager, $connection, $queueName){
        parent::__construct($connection);
        self::$queueName = $queueName;
        $this->pid = getmypid();
        $this->entityManager = $entityManager;
        $this->migracaoFichaFinanceiraService = $migracaoFichaFinanceiraService;
        $this->jenkins = true;
        $this->hcmParameters = $hcmParameters;
        $this->msg = array();
        $this->fpa_loteLancEven = Repositories::FPA_LOTELANCEVENTO;
        $this->fpa_itemlotelanc = Repositories::FPA_ITEMLOTELANC;
        $this->runAndFinish();
    }
    
	/**
     * @param string $message
     * @return void
     */
    public function consume($message) {        
        // Tempo de execucao deve ser ilimitado.
        // Tempo de execucao deve ser ilimitado.
        set_time_limit(0);
        error_reporting(E_ERROR | E_PARSE);
    	try {
            echo ">>>>>>>>>> Iniciando Processo <<<<<<<<<<".PHP_EOL;
            echo 'Pid = '.$this->pid.PHP_EOL;
            
            $consumerParams = json_decode($message, true)[0];
            
            $importacaoItensParams  = $consumerParams['IMPORTACAO_PARAMS'][0];
            $dataset = $consumerParams['DATASET'];
            
            $this->setParameters($importacaoItensParams);
            
            $nrorg = $this->hcmParameters->getNrorgTrabalho();
            $fpaLoteLancEvento = $importacaoItensParams['LOTELANCEVENTO'];
            
            $this->entityManager->beginTransaction();
            
            $this->fpaLoteLancEvento = $this->entityManager->getRepository($this->fpa_loteLancEven)->findOneBy(array('nrorg' => $nrorg, 'nrlotelancevento' => $fpaLoteLancEvento['NRLOTELANCEVENTO']));
            $itensLote = $this->entityManager->getRepository($this->fpa_itemlotelanciten)->findBy(array('nrorg' => $nrorg, 'nrlotelancevento' => $fpaLoteLancEvento['NRLOTELANCEVENTO']));
             
            if ($fpaLoteLancEvento['IDSTATUSLOTELANC'] == 'DIGITACAO' && count($itensLote) == $fpaLoteLancEvento['QTDEITENSTOTAL']){
                $this->fpaLoteLancEvento->setIdstatuslotelanc('PENDENTE');
                $this->entityManager->persist($this->fpaLoteLancEvento);
                $this->entityManager->flush();
            }
    
            // Define parametros do operador.
            $this->showAmbiente();
            
            $nritens = '';
            
            foreach($dataset as $row){
                $novoItem = $this->novoItemLoteFicha($nrorg, $row['NRVINCULOM'], $row['NREVENTOM'], $row['VREVENTOFOLHA'], $row['DTOCORRENCIA'], $fpaLoteLancEvento['NRLOTELANCEVENTO'], $row['VRREFFOLHA'], 'S', $row['DSCALCULO']);
                $nritens .= $novoItem->getNritlotelanc().","; 
            }
            
            $this->entityManager->commit();
            //Envia email para o operador informando o término do calculo.
            // $this->notificaMigracao($resultado, $nritens);
            $pid = explode(',', $calculoConsumer[0]['DSPIDPROCESSO']);
            return array(true, $this->pid, array_unique($pid));
            
        } catch (\Exception $e) {
            $this->entityManager->rollback();
            echo "Erro: ".$e->getMessage();
            $this->kill($this->pid);
            die();
        }
    }
    
    public function novoItemLoteFicha($nrorg, $nrvinculom, $nreventom, $vreventolote, $dtocorrencia, $nrlotelancevento, $vrreffolhalote, $idativo = 'S', $dsobservacao = null){
        $item = new $this->fpa_itemlotelanc;
        
        $item->setNrorg($nrorg);
        $item->setNreventom($nreventom);
        $item->setNrvinculom($nrvinculom);
        $item->setNrlotelancevento($nrlotelancevento);
        $item->setDtocorrencia($dtocorrencia);
        $item->setIdativo($idativo);
        $item->setDsobservacao($dsobservacao);
        $item->setVreventolote($vreventolote);
        $item->setVrreffolhalote($vrreffolhalote);
        
        $item->setDtinclusao(DateUtil::getDataAtual());
        $item->setNrorginclusao($this->hcmParameters->getNrorgTrabalho());
        $item->setCdoperinclusao($this->hcmParameters->getCdoperador());
        $item->setDtultatu(DateUtil::getDataAtual());
        $item->setNrorgultatu($this->hcmParameters->getNrorgTrabalho());
        $item->setCdoperultatu($this->hcmParameters->getCdoperador());
        
        $item->setNritlotelanc(\HCM\Util\NovoCodigo::geraCodigo($this->hcmParameters->getNrorgTrabalho(), 'FPA_ITEMLOTELANC', 1, 12, true));
        
        $this->entityManager->persist($item);
        $this->entityManager->flush();
        return $lotelancevento; 
    }
    
    public function notificaMigracao($resultado, $item){
        $cdoperador = FPA::getCdOperador();
        $operador = self::retornaOperadorLogado($cdoperador);

        $emailOperadorLogado = $operador->getDsemailoper();
        $nomeOperadorLogado = $operador->getNmoperador();
        
        $corpo_msg = $nomeOperadorLogado.','."<br>"."<br> Importação do item ".$item."Finalizado "."<br>"."<br>";

        $nome_destinatario  = $nomeOperadorLogado;
        
        $mail = $this->hcmParameters->returnParamsSmtp(true);
 
        if(!$mail){
            return;
        }
        
        try {
            
            $mail->newEmail($emailOperadorLogado,  //De/From
                $corpo_msg,                     //texto
                $assunto,                       // assunto    
                $nomeOperadorLogado,            //nome operador
                $nomeOperadorLogado,            //nome from
                $emailOperadorLogado           //from
                );
        }catch (Exception $e) {
            $contFail++;
        }
    }

    public function retornaOperadorLogado($cdoperador){
        $operador = \Setforms2\Shared\Registry::getEntityManager()->getRepository(Repositories::OPERADOR)->findOneBy(array('cdoperador' => $cdoperador));
        return $operador;
    }

    private function setParameters($consumerParams) {
        
        $this->dataSet           = $consumerParams["DATASET"];
        $this->dsemailoper       = $consumerParams["DSEMAILOPER"];
        $this->cdoperador        = $consumerParams["CDOPERADOR"];
        $this->dtmescompetencia  = $consumerParams["DTMESCOMPETENCIA"];
        $this->nrorg             = $consumerParams["NRORG"];
        
        foreach ($consumerParams["PARAMSHCM"] as $key => $value) {
            $this->hcmParameters->set($key, $value);
        }
    }

    private function showAmbiente() {
        $dataExecucao       = DateUtil::getDataAtual();

        $ambiente = "Org.: $this->nrorg\nCompetencia: $this->dtmescompetencia\nLote Ficha Financeira: $this->nrlotelancevento\n
                     Operador: $this->cdoperador\nData Execucao: $dataExecucao";
        
        echo $ambiente."<br>";
        echo "<br>"."---------------"."<br>";

        // set a propriedade DSOBSLOTELANC do registro em lotelacevento
        $this->fpaLoteLancEvento->setDsobslotelanc(str_replace("\n", " - ", $ambiente));
    }
}
