<?php

namespace HCM\FPA\Calculos\Geral;

use HCM\Util\Messages;
use HCM\Util\Repositories;
use HCM\Util\DateUtil;
use HCM\Util\FPA;
use HCM\FPA\Entity\FpatipocalculoEntity;

class MemoriaCalculo{

    private static $instance = null;
    protected $memoria;
    protected $cabecalho;
    protected $_vinculo;
    protected $nrorg;
    protected $_nr_tipo_calculo;
    protected $_sit_func_resumo;
    protected $_salario;
    protected $_dias_uteis;
    protected $_dias_rsr;
    protected $_mes_competencia;
    protected $_dt_pagamento;
    protected $_nrOcorrenciaCalculo;
    protected $escreveIncidencia;
    protected $escreveEventoIncidencia;
    protected $incidencias;
    protected $eventoIncid;
    protected $valoresRegra;
    protected $tipoMovimento;
    protected $calculoIncidencia;
    protected $temNmCalculo;
    protected $executaMemoriaCalculo;
    protected $nmArquivo;
    protected $nmPasta;
    protected $extensaoArquivo;
    protected $arquivo;
    protected $dataComp;

    public function criaCabecalho($entityManager,$hcmParameters, $vinculo, $tpCalc, $situFunc, $salario, $diasUteis, $diasRsr, $mesComp, $dtpagamento,
                                  $nrOcorrenciaCalculo,$nmcalculo,$gozoFerias,$afastamento = null){
        if($this->getExecutaMemoriaCalculo() == 'N'){
            return;
        }        
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
        
        $this->_vinculo = $vinculo;
        $this->nrorg = $vinculo->getNrorg();
        $this->_nr_tipo_calculo = $tpCalc;
        $this->_sit_func_resumo = $situFunc;
        $this->_salario = $salario;
        $this->_dias_uteis = $diasUteis;
        $this->_dias_rsr = $diasRsr;
        $this->_mes_competencia = $mesComp;
        $this->_dt_pagamento = substr($dtpagamento,0,10);
        $this->_nrOcorrenciaCalculo = $nrOcorrenciaCalculo;
        $this->_gozo_ferias = $gozoFerias;
        $dtAdmissao = explode(' ', $this->_vinculo->getDtadmissaovinc());
        $dtAdmissao = $dtAdmissao[0];
        $dtRescisao = explode(' ', $this->_vinculo->getDtrescisaovinc());
        $dtRescisao = $dtRescisao[0];

        $ocupacao = $this->entityManager->getRepository(Repositories::GPE_OCUPACAOH)->findOneBy(array('nrocupacaom' => $this->_vinculo->historico->getNrcargo(), 'nrorg' => $this->_vinculo->getNrorg()));
        $estruturaLegal = $this->entityManager->getRepository(Repositories::ESTRUTURAH)->findOneBy(array('nrestruturam' => $this->_vinculo->historico->getNrestrutlegal(), 'nrorg' => $this->_vinculo->getNrorg()));
        $estruturaGeren = $this->entityManager->getRepository(Repositories::ESTRUTURAH)->findOneBy(array('nrestruturam' => $this->_vinculo->historico->getNrestrutgeren(), 'nrorg' => $this->_vinculo->getNrorg()));
        if($this->_vinculo->historico->getNrestrutsind()){
            $estruturaSind = $this->entityManager->getRepository(Repositories::ESTRUTURAH)->findOneBy(array('nrestruturam' => $this->_vinculo->historico->getNrestrutsind(), 'nrorg' => $this->_vinculo->getNrorg()));
        }
        $this->cabecalho = array();
        $this->cabecalho[0] =
            "Tipo Calculo: ".$this->_nr_tipo_calculo.' '.$nmcalculo.' - Ocorrencia: '.$this->_nrOcorrenciaCalculo.PHP_EOL.
            'Vínculo: '.$this->_vinculo->getNrvinculom().' - '.$this->_vinculo->getNmvinculom().PHP_EOL.
            'Admissão: '.$dtAdmissao.' - Matricula: '.$this->_vinculo->getCdmatricula().' - Salario: '.$this->_salario.PHP_EOL.
            'Competencia: '.$this->_mes_competencia.' - Data Pagamento: '.$this->_dt_pagamento
        ;
        if($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_FERIAS){
            $dtIniGozo = $this->_gozo_ferias->getDtInicioGozo()->format('d/m/Y');
            $periodoGozo = $dtIniGozo;
            $periodoGozo .= '  -  '.$this->_gozo_ferias->getDtFimGozo()->format('d/m/Y');
            $this->cabecalho[0] .= PHP_EOL.'Dias Ferias: '.$periodoGozo;
        }if($dtRescisao){
            $this->cabecalho[0] .= PHP_EOL.'Data Rescisão: '.$dtRescisao;
        }if(is_object($ocupacao)){
            $this->cabecalho[0] .= PHP_EOL.'Ocupação: '.$ocupacao->getNmocupacaoh();
        }if(is_object($estruturaLegal)){
            $this->cabecalho[0] .= PHP_EOL.'Estrutura Legal: '.$estruturaLegal->getNmestruturah();
        }if(is_object($estruturaGeren)){
            $this->cabecalho[0] .= PHP_EOL.'Estrutura Gerencial: '.$estruturaGeren->getNmestruturah();
        }if(is_object($estruturaSind)){
            $this->cabecalho[0] .= PHP_EOL.'Estrutura Sindical: '.$estruturaSind->getNmestruturah();
        }

        $this->nmArquivo = $this->_vinculo->getNmvinculom().' '.$nmcalculo.'.txt';

    }

    public function escreveEventos($nrCalculo,$evento,$calculoEvento,$dtocorrencia,$valor_item,$referencia,$tipo_referencia = null,$base = null,$incidencia = null,$percentual = null,$eventoRelacionado = null,$valorEventoAnterior = null,$ValorEventoRecalculado = null){
        if($this->getExecutaMemoriaCalculo() == 'N'){
            return;
        }
        if(!array_key_exists($nrCalculo,$this->tipoMovimento)){
            $calcFolha = \Setforms2\Shared\Registry::getEntityManager()->getRepository(Repositories::FPA_CALCULOFOLHA)->getCalculoFolhaAndTpCalcMov($this->nrorg,$nrCalculo,$this->_nr_tipo_calculo);
            $this->temNmCalculo[$nrCalculo] = $calcFolha[0]['NMTPCALCMOV'];
            $this->tipoMovimento[$nrCalculo]['EVENTOS']['INDICE'] =
                PHP_EOL.PHP_EOL.PHP_EOL.'_______________________________________________________________________________________________________________'.
                PHP_EOL.PHP_EOL.'                                      '.$nrCalculo.' - '.$calcFolha[0]['NMTPCALCMOV'];
            $this->tipoMovimento[$nrCalculo]['EVENTOS']['SEPARAEVENTOS'] .= PHP_EOL.PHP_EOL.
                '___________________________________________________ Eventos ___________________________________________________'.PHP_EOL;
            ;
        }

        foreach($this->tipoMovimento as $nrCalc => $values){
            if($nrCalculo == $nrCalc){
                if($valor_item > 0){
                    $this->tipoMovimento[$nrCalc]['EVENTOS'][$evento->getNreventom()] = PHP_EOL.
                        'Evento: '. + $evento->getNreventom().' - '.$evento->historico->getNmeventoh().PHP_EOL.
                        'Data Ocorrencia: '.$dtocorrencia.PHP_EOL.
                        'Demonstrativo: '.$evento->historico->getIdeventodemonst().PHP_EOL.
                        'Valor: '.$valor_item.PHP_EOL;
                        if($valorEventoAnterior){$this->tipoMovimento[$nrCalc]['EVENTOS'][$evento->getNreventom()] .='Valor Calculo Anterior: '.$valorEventoAnterior.PHP_EOL;}
                        if($ValorEventoRecalculado){$this->tipoMovimento[$nrCalc]['EVENTOS'][$evento->getNreventom()] .='Valor Recalculado: '.$ValorEventoRecalculado.PHP_EOL;}
                        if($eventoRelacionado){$this->tipoMovimento[$nrCalc]['EVENTOS'][$evento->getNreventom()] .='Evento Relacionado: '.$eventoRelacionado.PHP_EOL;}
                        if($incidencia){$this->tipoMovimento[$nrCalc]['EVENTOS'][$evento->getNreventom()] .='incidencia: '.$incidencia.PHP_EOL;}
                        if($referencia){$this->tipoMovimento[$nrCalc]['EVENTOS'][$evento->getNreventom()] .='Referencia: '.$referencia.' - '.'Tipo Referencia: '.$tipo_referencia.PHP_EOL;}
                        if($base){$this->tipoMovimento[$nrCalc]['EVENTOS'][$evento->getNreventom()] .='Base: '.$base.PHP_EOL;}
                        if($percentual){$this->tipoMovimento[$nrCalc]['EVENTOS'][$evento->getNreventom()] .='Percentual: '.$percentual.PHP_EOL;}
                        if($calculoEvento){$this->tipoMovimento[$nrCalc]['EVENTOS'][$evento->getNreventom()] .='Calculo Do Evento: '.PHP_EOL.$calculoEvento.PHP_EOL;}
                    ;
                }
            }
        }
    }

    public function escreveIncidencia($tipo_incidencia,$base = null){
        if($this->getExecutaMemoriaCalculo() == 'N'){
            return;
        }
        if(!$this->escreveIncidencia){
            $this->incidencias = array();
        }else{
            foreach($this->incidencias as $tipo_incid){
                if($tipo_incidencia == $tipo_incid){
                    return;
                }
            }
        }
        if($base > 0){
            $incidencia = \Setforms2\Shared\Registry::getEntityManager()->getRepository(Repositories::FPA_TIPOINCIDE)->retornaTipoIncidencia($tipo_incidencia);
            $this->escreveIncidencia = $this->escreveIncidencia ? $this->escreveIncidencia :
                PHP_EOL.'_______________________________________________________________________________________________________________'.PHP_EOL.PHP_EOL.
                '                                                           INCIDENCIAS';
            $this->escreveIncidencia .= PHP_EOL.PHP_EOL.
                'Tipo de Incidencia: '.$tipo_incidencia .' - '.$incidencia->getNmtipoincide(). PHP_EOL .
                'Valor Total: '.$base.PHP_EOL.
                'Calculo: '.$this->calculoIncidencia.' = '.$base.PHP_EOL.
                'Gerado pelos Eventos: '.PHP_EOL . $this->escreveEventoIncidencia
                ;
        }
        $this->escreveEventoIncidencia = null;
        $this->calculoIncidencia = null;
        array_push($this->incidencias, $tipo_incidencia);
        
    }

    public function escreveEventoIncidencia($evento,$valor_item,$referencia,$incide){
        if($this->getExecutaMemoriaCalculo() == 'N'){
            return;
        }
        if(!$this->escreveEventoIncidencia){
            $this->eventoIncid = array();
        }else{
            foreach($this->eventoIncid as $eve_incid){
                if($evento->getNreventom() == $eve_incid){
                    return;
                }
            }
        }
        if($valor_item > 0){
            $this->escreveEventoIncidencia .= PHP_EOL.'              Evento: '. + $evento->getNreventom().' - '.$evento->historico->getNmeventoh().PHP_EOL.
                '              Valor: '.$valor_item.PHP_EOL.
                '              Referência: '.$referencia.PHP_EOL.
                '              Incide: '.$incide.PHP_EOL
            ;
            array_push($this->eventoIncid,$evento->getNreventom());
            $incide = $this->calculoIncidencia == null && $incide == '+' ? '' : $incide;
            $this->calculoIncidencia .= $incide.' '.$valor_item.' ';
        }
    }

    public function escreveRegras($nrCalculo,$regra,$evento,$valorRegra){
        if($this->getExecutaMemoriaCalculo() == 'N'){
            return;
        }
        if(array_key_exists($nrCalculo,$this->tipoMovimento)){

            $valoresRegra = $this->getValoresRegra();
            $calculoRegra = $regra->historico->getDsregra();
            foreach($valoresRegra as $key => $valor){
                $calculoRegra = str_replace(substr($key,1),$valor,$calculoRegra);
            }
            $calculoRegra = trim(preg_replace('/\t+/', '', $calculoRegra));
            $dsRegra = trim(preg_replace('/\t+/', '', $regra->historico->getDsregra()));
            if(!$this->tipoMovimento[$nrCalculo]['REGRAS']){
            $this->tipoMovimento[$nrCalculo]['REGRAS'] = PHP_EOL.PHP_EOL.
                '___________________________________________________ Regras ____________________________________________________';
            }
            $this->tipoMovimento[$nrCalculo]['REGRAS'] .= PHP_EOL.PHP_EOL.
                'Regra: '.$regra->getNrregram().' - '.$regra->historico->getNmregrah().PHP_EOL.
                'Evento: '. + $evento->getNreventom().' - '.$evento->historico->getNmeventoh().PHP_EOL.
                'Valor Evento: '.$valorRegra.PHP_EOL.
                'Descrição: '.$dsRegra.PHP_EOL.
                'Calculo: '.$calculoRegra.PHP_EOL;
            ;
        }
    }

    public function setMovimentos(){
        if($this->getExecutaMemoriaCalculo() == 'N'){
            return;
        }
        ksort($this->tipoMovimento);
        foreach($this->tipoMovimento as $nrCalculo =>  $movimento){
            $movimento = $this->setNmCalculo($nrCalculo,$movimento);
            ksort($movimento['EVENTOS']);
            ksort($movimento['REGRAS']);
            
            FPA::escreveArquivo($this->nmArquivo, $this->cabecalho);
            FPA::escreveArquivo($this->nmArquivo, implode('', $movimento['EVENTOS']));
            FPA::escreveArquivo($this->nmArquivo, $movimento['REGRAS']);
        }
    }

    public function setIncidencias(){
        if($this->getExecutaMemoriaCalculo() == 'N'){
            return;
        }
        
        FPA::escreveArquivo($this->nmArquivo, $this->escreveIncidencia);
    }

    public function setNmCalculo($nrCalculo,$movimento){
        if(!$this->temNmCalculo[$nrCalculo]) {
            $calcFolha = $this->entityManager->getRepository(Repositories::FPA_CALCULOFOLHA)->getCalculoFolhaAndTpCalcMov($this->nrorg, $nrCalculo, $this->_nr_tipo_calculo);
            $this->tipoMovimento[$nrCalculo]['EVENTOS']['INDICE'] .= $calcFolha[0]['NMTPCALCMOV'];
            $movimento['EVENTOS']['INDICE'] .= $calcFolha[0]['NMTPCALCMOV'];
            $this->temNmCalculo[$nrCalculo] = $calcFolha[0]['NMTPCALCMOV'];
        }
        return $movimento;
    }

    public static function getInstance() {
        if (self::$instance === null) {
            self::$instance = new self();
        }

        return self::$instance;
    }

    public function clear()
    {
        self::$instance = null;
    }

    public function getValoresRegra(){
        return $this->valoresRegra;
    }

    public function setValoresRegra($valores){
        $this->valoresRegra = $valores;
    }

    public function setExecutaMemoriaCalculo($executa){
        $this->executaMemoriaCalculo = $executa;
    }

    public function getExecutaMemoriaCalculo(){
        return is_null($this->executaMemoriaCalculo) ? 'N' : $this->executaMemoriaCalculo;
    }
    
    public function getNmArquivo(){
        return $this->nmArquivo;
    }
    
}