<?php
namespace HCM\Geral\Services;

use Doctrine\ORM\EntityManager;
use HCM\Geral\Repository\SituacaoFuncionalRepository;
use HCM\Util\HCMParameters;
use HCM\Util\Repositories;

class SituacaoFuncionalService {

    public function __construct(EntityManager $entityManager, HCMParameters $hcmParameters, SituacaoFuncionalRepository $situacaoFuncionalRepository) {
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
        $this->situacaoFuncionalRepository = $situacaoFuncionalRepository;
    }

    public function retornaUltimoHistoricoCompetencia($nrorg, $nrorgPadrao, $nrsitufuncm, $dtmescompetenc) {
        try {
            return $this->situacaoFuncionalRepository->retornaUltimoHistoricoCompetencia($nrorg, $nrorgPadrao, $nrsitufuncm, $dtmescompetenc);
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function deleteSituacao($dataset) {
        try {
            $this->entityManager->beginTransaction();
            $situacaoh = $this->entityManager->getRepository(Repositories::GPE_SITUFUNCH)->findOneBy(array("nrsitufuncm" => $dataset['NRSITUFUNCM'], "nrsitufunch" => $dataset['NRSITUFUNCH'],"nrorg" => $dataset['NRORG']));
            $this->entityManager->remove($situacaoh);
            $this->entityManager->flush();
            $situacaohh = $this->entityManager->getRepository(Repositories::GPE_SITUFUNCH)->findOneBy(array("nrsitufuncm" => $dataset['NRSITUFUNCM'],"nrorg" => $dataset['NRORG']));
            if(empty($situacaohh)) {
                $situacaom = $this->entityManager->getRepository(Repositories::GPE_SITUFUNCM)->findOneBy(array("nrsitufuncm" => $dataset['NRSITUFUNCM'],"nrorg" => $dataset['NRORG']));
                $this->entityManager->remove($situacaom);
                $this->entityManager->flush();
            }
            $this->entityManager->commit();
        } catch (\Exception $e) {            
            $this->entityManager->rollback();
            throw $e;
        }
    }

} 