<?php

namespace HCM\SST\Services;

use Doctrine\ORM\EntityManager;
use Folha\Entities\SstPerfilexame;
use Folha\Entities\SstItemperfilexame;
use HCM\Util\HCMParameters;
use HCM\Util\Messages;

class PerfilExameService {
    
    protected $entityManager;
    protected $hcmParameters;
    
    public function __construct(EntityManager $entityManager, HCMParameters $hcmParameters) {
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
    }
    
    public function deletePerfilExame($dataset) {
        
        $nrorg = $dataset["NRORG"];
        $nrperfilexame = $dataset["NRPERFILEXAME"];
        $itemperfilexame = SstItemperfilexame::findByNrperfilexameAndNrorg($nrperfilexame, $nrorg);
        if (isset($itemperfilexame[0])) {
            throw new \Exception(Messages::HCM05000_SST_PERFILEXAME_EXISTS_ITEMPERFILEXAME_ERROR, 10);
        }
        else {
            $this->entityManager->beginTransaction();
            $perfilexame = SstPerfilexame::findOneByNrperfilexameAndNrorg($nrperfilexame, $nrorg);
            $this->entityManager->remove($perfilexame);
            $this->entityManager->flush();
            $this->entityManager->commit();
        }
    }
}