<?php
/**
 * Created by PhpStorm.
 * User: felipesantos
 * Date: 01/07/2016
 * Time: 12:28
 */

namespace HCM\Util;


use Doctrine\ORM\EntityManager;

class DBWriter {

    private static $tableName = 'TKU_LOG';
    private static $INSERT = 'insert into TKU_LOG (TKU_LOG_ID,CREATED,DESCRIPTION,TABLENAME,PKVALUES,DATADIFF,EXTENDED_DATA,IP,TYPE,USERNAME) values (:TKU_LOG_ID,:CREATED,:DESCRIPTION,:TABLENAME,:PKVALUES,SUBSTR(:DATADIFF,1,2000),:EXTENDED_DATA,:IP,:TYPE,:USERNAME)';

    protected $row = array('CREATED'=>null,'DESCRIPTION'=>null,'TABLENAME'=>null,'PKVALUES'=>null,'DATADIFF'=>null,'EXTENDED_DATA'=>null,'IP'=>null,'TYPE'=>null,'USERNAME'=>null);

    private $entityManager;

    public function  __construct(EntityManager $entityManager) {
        $this->row['CREATED'] = date('d/m/Y H:i:s');
        $this->row['IP'] = getHostByName(getHostName());

        $this->entityManager = $entityManager;
    }

    public function error($message) {
        $this->row['DESCRIPTION'] = '[ERROR] '.$message;
        $this->log();
    }

    public function info($message) {
        $this->row['DESCRIPTION'] = '[INFO] '.$message;
        $this->log();
    }

    public function warning($message) {
        $this->row['DESCRIPTION'] = '[WARNING] '.$message;
        $this->log();
    }

    public function log() {
        //@todo verificar se existe log enable no config do projeto
        //if (Config::getInstance()->getLoggerEnabled() == true) {
            $this->write();
        //}
    }

    protected function write(){
        try{
            $std = $this->entityManager->getConnection()->prepare('SELECT MAX(TKU_LOG_ID) + 1 AS TKU_LOG_ID FROM TKU_LOG');
            $std->execute();
            $result = $std->fetchAll();
            $this->row['TKU_LOG_ID'] = $result[0]['TKU_LOG_ID'];
            $this->row['PKVALUES'] = substr($this->row['PKVALUES'],0,2000);
            $this->row['DATADIFF'] = substr($this->row['DATADIFF'],0,2000);
            $this->row['EXTENDED_DATA'] = substr($this->row['EXTENDED_DATA'],0,2000);
            $this->entityManager->getConnection()->prepare(self::$INSERT)->execute($this->row);
        } catch (\Exception $e) {
            $error = "Error on log generation: ".$e->getMessage();
            throw new \Exception($error);
        }
    }

    public function setUsername($username) {
        $this->row['USERNAME'] = $username;
    }

    public function setTableName($tableName){
        $this->row['TABLENAME'] = $tableName;
    }

    public function setType($type){
        $this->row['TYPE'] = $type;
    }

    public function setPkValues(array $pkValues) {
        //Casting to string to ensure right access to log when querying.
        foreach($pkValues as &$value) {
            $value = $value."";
        }

        $this->row['PKVALUES'] = json_encode($pkValues);
    }

    public function setDataDiff($datadiff) {
        $this->row['DATADIFF'] = json_encode($datadiff);
    }

    public function setExtendedData($extendedData) {
        $this->row['EXTENDED_DATA'] = json_encode($extendedData);
    }

} 