/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_MODP                                                     */
/* Tabela : MODPGTO                                                           */
/*                                                                            */
/* Criao:                                                                   */
/* 05/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_MODP' and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_MODP
GO

CREATE TRIGGER DTULTATU_MODP
ON MODPGTO
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'MODPGTO', null, 'CDMODPGTO=' + CDMODPGTO + ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE MODPGTO
      SET DTULTATUMPGT = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(MODPGTO.CDMODPGTO,0) = ISNULL(INSERTED.CDMODPGTO,0)) OR
            (ISNULL(MODPGTO.DSMODPGTO,0) = ISNULL(INSERTED.DSMODPGTO,0)) OR
            (ISNULL(MODPGTO.CDFORMPGTO,0) = ISNULL(INSERTED.CDFORMPGTO,0)) OR
            (ISNULL(MODPGTO.IDTPFORPGTOMOD,0) = ISNULL(INSERTED.IDTPFORPGTOMOD,0)) OR
            (ISNULL(MODPGTO.NRDIAPGFIXMOD,0) = ISNULL(INSERTED.NRDIAPGFIXMOD,0)) OR
            (ISNULL(MODPGTO.NRPARCPGTOMOD,0) = ISNULL(INSERTED.NRPARCPGTOMOD,0)) OR
            (ISNULL(MODPGTO.IDUTDIAPAGMOD,0) = ISNULL(INSERTED.IDUTDIAPAGMOD,0)) OR
            (ISNULL(MODPGTO.VRFATAJUPARC,0) = ISNULL(INSERTED.VRFATAJUPARC,0)) OR
            (ISNULL(MODPGTO.CDTIPORECE,0) = ISNULL(INSERTED.CDTIPORECE,0)) OR
            (ISNULL(MODPGTO.VRPEDESMODPG,0) = ISNULL(INSERTED.VRPEDESMODPG,0)) OR
            (ISNULL(MODPGTO.IDLANCPEDMOD,0) = ISNULL(INSERTED.IDLANCPEDMOD,0));
   END;
END;
GO


